#include "calo_sum_orbit_processor.h"

#include <cassert>

int CaloSumOrbitProcessor::ProcessBlock(MemRegion &readable_block, WriteMemRegion &writeable_block,
                                        BxMetadata meta) {
  struct BxMetadataType {
    uint32_t bx;
    uint32_t orbit;
  };

  using SourceDataType = blockCaloSum;
  using SinkDataType = uint32_t;
  //  const uint32_t source_data_length = 6;

  assert(readable_block.CheckBounds(sizeof(SourceDataType)));

  SourceDataType *bl = readable_block.Scan<SourceDataType>();
  //  BxData<SinkDataType, source_data_length> bx_data;

  writeable_block.Fill(BxMetadataType{meta.bx, meta.orbit});
  writeable_block.Fill(bl->calo_sum, sizeof(bl->calo_sum));

  return 6;  // Original left counts at zero
}